<template>
  <div data-aos="fade" class="section-price-list">
    <div class="section">
      <div class="price-list">
        <div class="bottom-silver-line">
          <div class="price-list tabs">
            <div class="price-list tabs__tab"
                 v-for="(item, idx) in titleTabs"
                 :key="`${idx}-tab`"
                 @click="changeTab(idx)"
                 :class="{'active': tab === idx}">
              {{ item.name }}
            </div>
          </div>
        </div>

        <div class="price-list__table">
          <!--Desktop-->
          <table
            v-for="(product, idx) in currentData"
            :key="`${idx}-product`"
            class="table desktop"
          >
            <thead>
            <tr>
              <th scope="col">{{ product.name }}</th>
              <th
                scope="col"
                v-for="(time, t) in product.attributes[1].terms"
              >
                {{ time.slug }}
              </th>
            </tr>
            </thead>
            <tbody>
            <tr
              v-for="(packg, p) in product.attributes[0].terms"
              :key="`${p}-package`"
            >
              <th scope="row">{{ packg.name }}</th>
              <td
                v-for="(variant, v) in product.variations"
                :key="`${v}-variant`"
                v-if="packg.slug === variant.attributes.attribute_pa_pakage">
                <span v-if="variant.display_price">
                              {{ variant.display_price }} zł
                            </span>
              </td>
            </tr>
            </tbody>
          </table>

          <!--Mobile-->
          <table
            v-for="(product, idx) in currentData"
            :key="`${idx}-product`"
            class="table mobile"
          >
            <thead>
            <tr>
              <th scope="col">{{ product.name }}</th>
            </tr>
            </thead>
            <tbody>
            <table
              v-for="(packg, p) in product.attributes[0].terms"
              :key="`${p}-package`"
              class="table">
              <thead>
              <tr>
                <th scope="col">{{ packg.name }}</th>
              </tr>
              </thead>
              <tbody>
              <tr v-for="(time, t) in product.attributes[1].terms">
                <td>{{ time.slug }}</td>
                <td v-for="(variant, v) in product.variations"
                    :key="`${v}-variant`"
                    v-if="packg.slug === variant.attributes.attribute_pa_pakage && time.slug === variant.attributes.attribute_pa_time">
                   <span v-if="variant.display_price === null">
                   - zł
                   </span>
                  <span v-else-if="time.slug === variant.attributes.attribute_pa_time">
                  {{ variant.display_price }} zł
                  </span>
                </td>
              </tr>
              </tbody>
            </table>
            </tbody>
          </table>

        </div>
      </div>
    </div>
  </div>
</template>

<script>

export default {
  props: {
    data: {
      type: Object,
      required: true,
    }
  },
  data() {
    return {
      titleTabs: [
        {name: "Wszystkie", id: 0},
      ],

      tab: 0,
      currentProducts: [...this.data.products],

    }
  },
  methods: {
    changeTab(idx) {
      this.tab = idx;
      this.$forceUpdate()
    }
  },
  created() {
    if (this.data && this.data.categories) {
      this.data.categories.forEach((category, idx) => {
        this.titleTabs.push({name: category.cat_name, id: category.cat_ID})
      })

    }
  },
  watch: {
    tab(newVal) {
      const currentCategory = this.titleTabs[this.tab]
      if (currentCategory.id === 0) {
        this.currentData = this.data.products;
        return this.tab
      }
      const result = [];
      this.data.products.forEach(product => {
        product.category_ids.forEach((idCategory) => {
          if (idCategory === currentCategory.id) {
            result.push(product);
          }
        })
      })
      this.currentData = result;
      return this.tab
    }
  },
  computed: {
    currentData: {
      set(newVal) {
        this.currentProducts = newVal;
      },
      get() {
        return this.currentProducts;
      }
    }
  }
}
</script>
